/[gentoo-x86]/eclass/webapp.eclass
Gentoo

Diff of /eclass/webapp.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.34 Revision 1.41
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.34 2005/07/11 15:08:06 swegener Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.41 2006/05/19 19:24:21 flameeyes Exp $
4# 4#
5# eclass/webapp.eclass 5# eclass/webapp.eclass
6# Eclass for installing applications to run under a web server 6# Eclass for installing applications to run under a web server
7# 7#
8# Part of the implementation of GLEP #11 8# Part of the implementation of GLEP #11
9# 9#
10# Author(s) Stuart Herbert <stuart@gentoo.org> 10# Author(s) Stuart Herbert <stuart@gentoo.org>
11# Renat Lumpau <rl03@gentoo.org>
12# Gunnar Wrobel <wrobel@gentoo.org>
11# 13#
12# ------------------------------------------------------------------------ 14# ------------------------------------------------------------------------
13# 15#
14# The master copy of this eclass is held in Stu's subversion repository. 16# The master copy of this eclass is held in our subversion repository.
17# http://svn.gnqs.org/projects/vhost-tools/browser/
15# 18#
16# If you make changes to this file and don't tell Stu, chances are that 19# If you make changes to this file and don't tell us, chances are that
17# your changes will be overwritten the next time Stu releases a new version 20# your changes will be overwritten the next time we release a new version
18# of webapp-config. 21# of webapp-config.
19# 22#
20# ------------------------------------------------------------------------ 23# ------------------------------------------------------------------------
21 24
22SLOT="${PVR}" 25SLOT="${PVR}"
23IUSE="$IUSE vhosts" 26IUSE="vhosts"
24DEPEND="$DEPEND net-www/webapp-config app-portage/gentoolkit" 27DEPEND="app-admin/webapp-config"
28RDEPEND="${DEPEND}"
25 29
26EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm 30EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm
27 31
28INSTALL_DIR="/$PN" 32INSTALL_DIR="/${PN}"
29IS_UPGRADE=0 33IS_UPGRADE=0
30IS_REPLACE=0 34IS_REPLACE=0
31 35
32INSTALL_CHECK_FILE="installed_by_webapp_eclass" 36INSTALL_CHECK_FILE="installed_by_webapp_eclass"
33 37
34ETC_CONFIG="/etc/vhosts/webapp-config" 38ETC_CONFIG="${ROOT}/etc/vhosts/webapp-config"
39WEBAPP_CONFIG="${ROOT}/usr/sbin/webapp-config"
40
41# ------------------------------------------------------------------------
42# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY
43#
44# Load the config file /etc/vhosts/webapp-config
45#
46# Supports both the old bash version, and the new python version
47#
48# ------------------------------------------------------------------------
49
50function webapp_read_config ()
51{
52 if has_version '>=app-admin/webapp-config-1.50'; then
53 ENVVAR=$(${WEBAPP_CONFIG} --query ${PN} ${PVR}) || die "Could not read settings from webapp-config!"
54 eval ${ENVVAR}
55 else
56 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}"
57 fi
58}
35 59
36# ------------------------------------------------------------------------ 60# ------------------------------------------------------------------------
37# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY 61# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY
38# 62#
39# Check whether a specified file exists within the image/ directory 63# Check whether a specified file exists within the image/ directory
46 70
47function webapp_checkfileexists () 71function webapp_checkfileexists ()
48{ 72{
49 local my_prefix 73 local my_prefix
50 74
51 [ -n "$2" ] && my_prefix="$2/" || my_prefix= 75 [ -n "${2}" ] && my_prefix="${2}/" || my_prefix=
52 76
53 if [ ! -e "${my_prefix}$1" ]; then 77 if [ ! -e "${my_prefix}${1}" ]; then
54 msg="ebuild fault: file '$1' not found" 78 msg="ebuild fault: file '${1}' not found"
55 eerror "$msg" 79 eerror "$msg"
56 eerror "Please report this as a bug at http://bugs.gentoo.org/" 80 eerror "Please report this as a bug at http://bugs.gentoo.org/"
57 die "$msg" 81 die "$msg"
58 fi 82 fi
59} 83}
64 88
65function webapp_check_installedat 89function webapp_check_installedat
66{ 90{
67 local my_output 91 local my_output
68 92
69 /usr/sbin/webapp-config --show-installed -h localhost -d "$INSTALL_DIR" 2> /dev/null 93 ${WEBAPP_CONFIG} --show-installed -h localhost -d "${INSTALL_DIR}" 2> /dev/null
70} 94}
71 95
72# ------------------------------------------------------------------------ 96# ------------------------------------------------------------------------
73# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY 97# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY
74# ------------------------------------------------------------------------
75
76function webapp_import_config ()
77{
78 if [ -z "${MY_HTDOCSDIR}" ]; then
79 . /etc/conf.d/webapp-config
80 fi
81
82 if [ -z "${MY_HTDOCSDIR}" ]; then
83 libsh_edie "/etc/conf.d/webapp-config not imported"
84 fi
85}
86
87# ------------------------------------------------------------------------
88# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY
89# 98#
90# ------------------------------------------------------------------------ 99# ------------------------------------------------------------------------
91 100
92function webapp_strip_appdir () 101function webapp_strip_appdir ()
93{ 102{
94 local my_stripped="$1" 103 local my_stripped="${1}"
95 echo "$1" | sed -e "s|${MY_APPDIR}/||g;" 104 echo "${1}" | sed -e "s|${MY_APPDIR}/||g;"
96} 105}
97 106
98function webapp_strip_d () 107function webapp_strip_d ()
99{ 108{
100 echo "$1" | sed -e "s|${D}||g;" 109 echo "${1}" | sed -e "s|${D}||g;"
101} 110}
102 111
103function webapp_strip_cwd () 112function webapp_strip_cwd ()
104{ 113{
105 local my_stripped="$1" 114 local my_stripped="${1}"
106 echo "$1" | sed -e 's|/./|/|g;' 115 echo "${1}" | sed -e 's|/./|/|g;'
107} 116}
108 117
109# ------------------------------------------------------------------------ 118# ------------------------------------------------------------------------
110# EXPORTED FUNCTION - FOR USE IN EBUILDS 119# EXPORTED FUNCTION - FOR USE IN EBUILDS
111# 120#
114# @param $1 - config file 123# @param $1 - config file
115# ------------------------------------------------------------------------ 124# ------------------------------------------------------------------------
116 125
117function webapp_configfile () 126function webapp_configfile ()
118{ 127{
128 local m=""
129 for m in "$@" ; do
119 webapp_checkfileexists "$1" "$D" 130 webapp_checkfileexists "${m}" "${D}"
120 131
121 local MY_FILE="`webapp_strip_appdir \"$1\"`" 132 local MY_FILE="$(webapp_strip_appdir "${m}")"
122 MY_FILE="`webapp_strip_cwd \"$MY_FILE\"`" 133 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")"
123 134
124 einfo "(config) $MY_FILE" 135 einfo "(config) ${MY_FILE}"
125 echo "$MY_FILE" >> ${D}${WA_CONFIGLIST} 136 echo "${MY_FILE}" >> ${D}/${WA_CONFIGLIST}
137 done
126} 138}
127 139
128# ------------------------------------------------------------------------ 140# ------------------------------------------------------------------------
129# EXPORTED FUNCTION - FOR USE IN EBUILDS 141# EXPORTED FUNCTION - FOR USE IN EBUILDS
130# 142#
134# @param $1 - the script to run 146# @param $1 - the script to run
135# ------------------------------------------------------------------------ 147# ------------------------------------------------------------------------
136 148
137function webapp_hook_script () 149function webapp_hook_script ()
138{ 150{
139 webapp_checkfileexists "$1" 151 webapp_checkfileexists "${1}"
140 152
141 einfo "(hook) $1" 153 einfo "(hook) ${1}"
142 cp "$1" "${D}${MY_HOOKSCRIPTSDIR}/`basename $1`" || die "Unable to install $1 into ${D}${MY_HOOKSCRIPTSDIR}/" 154 cp "${1}" "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")" || die "Unable to install ${1} into ${D}/${MY_HOOKSCRIPTSDIR}/"
143 chmod 555 "${D}${MY_HOOKSCRIPTSDIR}/`basename $1`" 155 chmod 555 "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")"
144} 156}
145 157
146# ------------------------------------------------------------------------ 158# ------------------------------------------------------------------------
147# EXPORTED FUNCTION - FOR USE IN EBUILDS 159# EXPORTED FUNCTION - FOR USE IN EBUILDS
148# 160#
152# @param $2 - the file to install 164# @param $2 - the file to install
153# ------------------------------------------------------------------------ 165# ------------------------------------------------------------------------
154 166
155function webapp_postinst_txt () 167function webapp_postinst_txt ()
156{ 168{
157 webapp_checkfileexists "$2" 169 webapp_checkfileexists "${2}"
158 170
159 einfo "(rtfm) $2 (lang: $1)" 171 einfo "(info) ${2} (lang: ${1})"
160 cp "$2" "${D}${MY_APPDIR}/postinst-$1.txt" 172 cp "${2}" "${D}/${MY_APPDIR}/postinst-${1}.txt"
161} 173}
162 174
163# ------------------------------------------------------------------------ 175# ------------------------------------------------------------------------
164# EXPORTED FUNCTION - FOR USE IN EBUILDS 176# EXPORTED FUNCTION - FOR USE IN EBUILDS
165# 177#
169# @param $2 - the file to install 181# @param $2 - the file to install
170# ------------------------------------------------------------------------ 182# ------------------------------------------------------------------------
171 183
172function webapp_postupgrade_txt () 184function webapp_postupgrade_txt ()
173{ 185{
174 webapp_checkfileexists "$2" 186 webapp_checkfileexists "${2}"
175 187
176 einfo "(rtfm) $2 (lang: $1)" 188 einfo "(info) ${2} (lang: ${1})"
177 cp "$2" "${D}${MY_APPDIR}/postupgrade-$1.txt" 189 cp "${2}" "${D}/${MY_APPDIR}/postupgrade-${1}.txt"
178}
179
180# ------------------------------------------------------------------------
181# DEPRECATED FUNCTION
182#
183# It never worked anyway
184
185function webapp_runbycgibin ()
186{
187 if [ -n "$WARN_RUNBYCGIBIN" ] ; then
188 return
189 fi
190
191 ewarn "This ebuild uses webapp.eclass's webapp_runbycgibin, which is now"
192 ewarn "deprecated. Please file a bug about this in Bugzilla."
193 WARN_RUNBYCGIBIN=1
194} 190}
195 191
196# ------------------------------------------------------------------------ 192# ------------------------------------------------------------------------
197# EXPORTED FUNCTION - FOR USE IN EBUILDS 193# EXPORTED FUNCTION - FOR USE IN EBUILDS
198# 194#
206# 202#
207# ------------------------------------------------------------------------ 203# ------------------------------------------------------------------------
208 204
209function webapp_serverowned () 205function webapp_serverowned ()
210{ 206{
207 local a=""
208 local m=""
209 if [ "${1}" = "-R" ]; then
210 shift
211 for m in "$@" ; do
212 for a in $(find ${D}/${m}); do
213 a=${a/${D}\/\///}
214 webapp_checkfileexists "${a}" "$D"
215 local MY_FILE="$(webapp_strip_appdir "${a}")"
216 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")"
217
218 einfo "(server owned) ${MY_FILE}"
219 echo "${MY_FILE}" >> "${D}/${WA_SOLIST}"
220 done
221 done
222 else
223 for m in "$@" ; do
211 webapp_checkfileexists "$1" "$D" 224 webapp_checkfileexists "${m}" "$D"
212 local MY_FILE="`webapp_strip_appdir \"$1\"`" 225 local MY_FILE="$(webapp_strip_appdir "${m}")"
213 MY_FILE="`webapp_strip_cwd \"$MY_FILE\"`" 226 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")"
214 227
215 einfo "(server owned) $MY_FILE" 228 einfo "(server owned) ${MY_FILE}"
216 echo "$MY_FILE" >> "${D}${WA_SOLIST}" 229 echo "${MY_FILE}" >> "${D}/${WA_SOLIST}"
230 done
231 fi
217} 232}
218 233
219# ------------------------------------------------------------------------ 234# ------------------------------------------------------------------------
220# EXPORTED FUNCTION - FOR USE IN EBUILDS 235# EXPORTED FUNCTION - FOR USE IN EBUILDS
221# 236#
230# config file's name 245# config file's name
231# ------------------------------------------------------------------------ 246# ------------------------------------------------------------------------
232 247
233function webapp_server_configfile () 248function webapp_server_configfile ()
234{ 249{
235 webapp_checkfileexists "$2" 250 webapp_checkfileexists "${2}"
236 251
237 # sort out what the name will be of the config file 252 # sort out what the name will be of the config file
238 253
239 local my_file 254 local my_file
240 255
241 if [ -z "$3" ]; then 256 if [ -z "${3}" ]; then
242 my_file="$1-`basename $2`" 257 my_file="${1}-$(basename "${2}")"
243 else 258 else
244 my_file="$1-$3" 259 my_file="${1}-${3}"
245 fi 260 fi
246 261
247 # warning: 262 # warning:
248 # 263 #
249 # do NOT change the naming convention used here without changing all 264 # do NOT change the naming convention used here without changing all
250 # the other scripts that also rely upon these names 265 # the other scripts that also rely upon these names
251 266
252 einfo "($1) config file '$my_file'" 267 einfo "(${1}) config file '${my_file}'"
253 cp "$2" "${D}${MY_SERVERCONFIGDIR}/${my_file}" 268 cp "${2}" "${D}/${MY_SERVERCONFIGDIR}/${my_file}"
254} 269}
255 270
256# ------------------------------------------------------------------------ 271# ------------------------------------------------------------------------
257# EXPORTED FUNCTION - FOR USE IN EBUILDS 272# EXPORTED FUNCTION - FOR USE IN EBUILDS
258# 273#
265# a new db from scratch) 280# a new db from scratch)
266# ------------------------------------------------------------------------ 281# ------------------------------------------------------------------------
267 282
268function webapp_sqlscript () 283function webapp_sqlscript ()
269{ 284{
270 webapp_checkfileexists "$2" 285 webapp_checkfileexists "${2}"
271 286
272 # create the directory where this script will go 287 # create the directory where this script will go
273 # 288 #
274 # scripts for specific database engines go into their own subdirectory 289 # scripts for specific database engines go into their own subdirectory
275 # just to keep things readable on the filesystem 290 # just to keep things readable on the filesystem
276 291
277 if [ ! -d "${D}${MY_SQLSCRIPTSDIR}/$1" ]; then 292 if [ ! -d "${D}/${MY_SQLSCRIPTSDIR}/${1}" ]; then
278 mkdir -p "${D}${MY_SQLSCRIPTSDIR}/$1" || libsh_die "unable to create directory ${D}${MY_SQLSCRIPTSDIR}/$1" 293 mkdir -p "${D}/${MY_SQLSCRIPTSDIR}/${1}" || die "unable to create directory ${D}/${MY_SQLSCRIPTSDIR}/${1}"
279 fi 294 fi
280 295
281 # warning: 296 # warning:
282 # 297 #
283 # do NOT change the naming convention used here without changing all 298 # do NOT change the naming convention used here without changing all
284 # the other scripts that also rely upon these names 299 # the other scripts that also rely upon these names
285 300
286 # are we dealing with an 'upgrade'-type script? 301 # are we dealing with an 'upgrade'-type script?
287 if [ -n "$3" ]; then 302 if [ -n "${3}" ]; then
288 # yes we are 303 # yes we are
289 einfo "($1) upgrade script from ${PN}-${PVR} to $3" 304 einfo "(${1}) upgrade script from ${PN}-${PVR} to ${3}"
290 cp "$2" "${D}${MY_SQLSCRIPTSDIR}/$1/${3}_to_${PVR}.sql" 305 cp "${2}" "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
291 chmod 600 "${D}${MY_SQLSCRIPTSDIR}/$1/${3}_to_${PVR}.sql" 306 chmod 600 "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
292 else 307 else
293 # no, we are not 308 # no, we are not
294 einfo "($1) create script for ${PN}-${PVR}" 309 einfo "(${1}) create script for ${PN}-${PVR}"
295 cp "$2" "${D}${MY_SQLSCRIPTSDIR}/$1/${PVR}_create.sql" 310 cp "${2}" "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
296 chmod 600 "${D}${MY_SQLSCRIPTSDIR}/$1/${PVR}_create.sql" 311 chmod 600 "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
297 fi 312 fi
298} 313}
299 314
300# ------------------------------------------------------------------------ 315# ------------------------------------------------------------------------
301# EXPORTED FUNCTION - call from inside your ebuild's src_install AFTER 316# EXPORTED FUNCTION - call from inside your ebuild's src_install AFTER
302# everything else has run 317# everything else has run
303# 318#
304# For now, we just make sure that root owns everything, and that there 319# For now, we just make sure that root owns everything, and that there
305# are no setuid files. I'm sure this will change significantly before 320# are no setuid files.
306# the final version!
307# ------------------------------------------------------------------------ 321# ------------------------------------------------------------------------
308 322
309function webapp_src_install () 323function webapp_src_install ()
310{ 324{
311 chown -R "${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID}" "${D}/" 325 chown -R "${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID}" "${D}/"
312 chmod -R u-s "${D}/" 326 chmod -R u-s "${D}/"
313 chmod -R g-s "${D}/" 327 chmod -R g-s "${D}/"
314 328
315 keepdir "${MY_PERSISTDIR}" 329 keepdir "${MY_PERSISTDIR}"
316 fowners "root:root" "${MY_PERSISTDIR}" 330 fowners "root:0" "${MY_PERSISTDIR}"
317 fperms 755 "${MY_PERSISTDIR}" 331 fperms 755 "${MY_PERSISTDIR}"
318 332
319 # to test whether or not the ebuild has correctly called this function 333 # to test whether or not the ebuild has correctly called this function
320 # we add an empty file to the filesystem 334 # we add an empty file to the filesystem
321 # 335 #
336 350
337function webapp_pkg_setup () 351function webapp_pkg_setup ()
338{ 352{
339 # add sanity checks here 353 # add sanity checks here
340 354
341 if [ "$SLOT+" != "${PVR}+" ]; then 355 if [ "${SLOT}+" != "${PVR}+" ]; then
356 # special case - some ebuilds *do* need to overwride the SLOT
357 if [ "${WEBAPP_MANUAL_SLOT}" != "yes" ]; then
342 die "ebuild sets SLOT, overrides webapp.eclass" 358 die "ebuild sets SLOT, overrides webapp.eclass"
359 else
360 ewarn
361 ewarn "This ebuild overrides the default SLOT behaviour for webapps"
362 ewarn "If this package installs files into the htdocs dir, this is"
363 ewarn "probably a bug in the ebuild."
364 ewarn
365 fi
343 fi 366 fi
344 367
345 # pull in the shared configuration file 368 # pull in the shared configuration file
346 369
347 G_HOSTNAME="localhost" 370 G_HOSTNAME="localhost"
348 . "${ETC_CONFIG}" || die "Unable to open file ${ETC_CONFIG}" 371 webapp_read_config
349 372
350 # are we installing a webapp-config solution over the top of a 373 # are we installing a webapp-config solution over the top of a
351 # non-webapp-config solution? 374 # non-webapp-config solution?
352 375
353 if ! use vhosts ; then 376 if ! use vhosts ; then
354 local my_dir="$VHOST_ROOT/$MY_HTDOCSBASE/$PN" 377 local my_dir="${ROOT}${VHOST_ROOT}/${MY_HTDOCSBASE}/${PN}"
355 local my_output 378 local my_output
356 379
357 if [ -d "$my_dir" ] ; then 380 if [ -d "${my_dir}" ] ; then
358 einfo "You already have something installed in $my_dir" 381 einfo "You already have something installed in ${my_dir}"
359 einfo "Are you trying to install over the top of something I cannot upgrade?" 382 einfo "Are you trying to install over the top of something I cannot upgrade?"
360 383
361 my_output="`webapp_check_installedat`" 384 my_output="$(webapp_check_installedat)"
362 385
363 if [ "$?" != "0" ]; then 386 if [ "$?" != "0" ]; then
364 387
365 # okay, whatever is there, it isn't webapp-config-compatible 388 # okay, whatever is there, it isn't webapp-config-compatible
366 ewarn 389 ewarn
367 ewarn "Whatever is in $my_dir, it's not" 390 ewarn "Whatever is in ${my_dir}, it's not"
368 ewarn "compatible with webapp-config." 391 ewarn "compatible with webapp-config."
369 ewarn 392 ewarn
370 ewarn "This ebuild may be overwriting important files." 393 ewarn "This ebuild may be overwriting important files."
371 ewarn 394 ewarn
372 elif [ "`echo $my_output | awk '{ print $1 }'`" != "$PN" ]; then 395 elif [ "$(echo ${my_output} | awk '{ print $1 }')" != "${PN}" ]; then
373 eerror "$my_dir contains $my_output" 396 eerror "${my_dir} contains ${my_output}"
374 eerror "I cannot upgrade that" 397 eerror "I cannot upgrade that"
375 die "Cannot upgrade contents of $my_dir" 398 die "Cannot upgrade contents of ${my_dir}"
376 else 399 else
377 einfo 400 einfo
378 einfo "I can upgrade the contents of $my_dir" 401 einfo "I can upgrade the contents of ${my_dir}"
379 einfo 402 einfo
380 fi 403 fi
381 fi 404 fi
382 fi 405 fi
383} 406}
384 407
385function webapp_someunusedfunction ()
386{
387 # are we emerging something that is already installed?
388
389 if [ -d "${D}${MY_APPROOT}/${MY_APPSUFFIX}" ]; then
390 # yes we are
391 ewarn "Removing existing copy of ${PN}-${PVR}"
392 rm -rf "${D}${MY_APPROOT}/${MY_APPSUFFIX}"
393 fi
394}
395
396function webapp_getinstalltype () 408function webapp_getinstalltype ()
397{ 409{
398 # or are we upgrading? 410 # or are we upgrading?
399 411
400 if ! use vhosts ; then 412 if ! use vhosts ; then
401 # we only run webapp-config if vhosts USE flag is not set 413 # we only run webapp-config if vhosts USE flag is not set
402 414
403 local my_output 415 local my_output
404 416
405 my_output="`webapp_check_installedat`" 417 my_output="$(webapp_check_installedat)"
406 418
407 if [ "$?" = "0" ] ; then 419 if [ "${?}" = "0" ] ; then
408 # something is already installed there 420 # something is already installed there
409 # 421 #
410 # make sure it isn't the same version 422 # make sure it isn't the same version
411 423
412 local my_pn="`echo $my_output | awk '{ print $1 }'`" 424 local my_pn="$(echo ${my_output} | awk '{ print $1 }')"
413 local my_pvr="`echo $my_output | awk '{ print $2 }'`" 425 local my_pvr="$(echo ${my_output} | awk '{ print $2 }')"
414 426
415 REMOVE_PKG="${my_pn}-${my_pvr}" 427 REMOVE_PKG="${my_pn}-${my_pvr}"
416 428
417 if [ "$my_pn" == "$PN" ]; then 429 if [ "${my_pn}" == "${PN}" ]; then
418 if [ "$my_pvr" != "$PVR" ]; then 430 if [ "${my_pvr}" != "${PVR}" ]; then
419 einfo "This is an upgrade" 431 einfo "This is an upgrade"
420 IS_UPGRADE=1 432 IS_UPGRADE=1
421 else 433 else
422 einfo "This is a re-installation" 434 einfo "This is a re-installation"
423 IS_REPLACE=1 435 IS_REPLACE=1
424 fi 436 fi
425 else 437 else
426 einfo "$my_ouptut is installed there" 438 einfo "${my_output} is installed there"
427 fi 439 fi
428 else 440 else
429 einfo "This is an installation" 441 einfo "This is an installation"
430 fi 442 fi
431 fi 443 fi
445 dodir "${MY_SERVERCONFIGDIR}" 457 dodir "${MY_SERVERCONFIGDIR}"
446} 458}
447 459
448function webapp_pkg_postinst () 460function webapp_pkg_postinst ()
449{ 461{
450 . "${ETC_CONFIG}" 462 webapp_read_config
451 463
452 # sanity checks, to catch bugs in the ebuild 464 # sanity checks, to catch bugs in the ebuild
453 465
454 if [ ! -f "${MY_APPDIR}/${INSTALL_CHECK_FILE}" ]; then 466 if [ ! -f "${ROOT}${MY_APPDIR}/${INSTALL_CHECK_FILE}" ]; then
455 eerror 467 eerror
456 eerror "This ebuild did not call webapp_src_install() at the end" 468 eerror "This ebuild did not call webapp_src_install() at the end"
457 eerror "of the src_install() function" 469 eerror "of the src_install() function"
458 eerror 470 eerror
459 eerror "Please log a bug on http://bugs.gentoo.org" 471 eerror "Please log a bug on http://bugs.gentoo.org"
463 eerror 475 eerror
464 die "Ebuild did not call webapp_src_install() - report to http://bugs.gentoo.org" 476 die "Ebuild did not call webapp_src_install() - report to http://bugs.gentoo.org"
465 fi 477 fi
466 478
467 # if 'vhosts' is not set in your USE flags, we install a copy of 479 # if 'vhosts' is not set in your USE flags, we install a copy of
468 # this application in /var/www/localhost/htdocs/${PN}/ for you 480 # this application in ${ROOT}/var/www/localhost/htdocs/${PN}/ for you
469 481
470 if ! use vhosts ; then 482 if ! use vhosts ; then
471 echo 483 echo
472 einfo "vhosts USE flag not set - auto-installing using webapp-config" 484 einfo "vhosts USE flag not set - auto-installing using webapp-config"
473 485
474 webapp_getinstalltype 486 webapp_getinstalltype
475 487
476 G_HOSTNAME="localhost" 488 G_HOSTNAME="localhost"
477 . "${ETC_CONFIG}"
478
479 local my_mode=-I 489 local my_mode=-I
490 webapp_read_config
480 491
481 if [ "$IS_REPLACE" = "1" ]; then 492 if [ "${IS_REPLACE}" = "1" ]; then
482 einfo "${PN}-${PVR} is already installed - replacing" 493 einfo "${PN}-${PVR} is already installed - replacing"
483 my_mode=-I 494 my_mode=-I
484 elif [ "$IS_UPGRADE" = "1" ]; then 495 elif [ "${IS_UPGRADE}" = "1" ]; then
485 einfo "$REMOVE_PKG is already installed - upgrading" 496 einfo "${REMOVE_PKG} is already installed - upgrading"
486 my_mode=-U 497 my_mode=-U
487 else 498 else
488 einfo "${PN}-${PVR} is not installed - using install mode" 499 einfo "${PN}-${PVR} is not installed - using install mode"
489 fi 500 fi
490 501
491 my_cmd="/usr/sbin/webapp-config $my_mode -h localhost -u root -d $INSTALL_DIR ${PN} ${PVR}" 502 my_cmd="${WEBAPP_CONFIG} ${my_mode} -h localhost -u root -d ${INSTALL_DIR} ${PN} ${PVR}"
492 einfo "Running $my_cmd" 503 einfo "Running ${my_cmd}"
493 $my_cmd 504 ${my_cmd}
494 505
495 # remove the old version 506 # remove the old version
496 # 507 #
497 # why do we do this? well ... 508 # why do we do this? well ...
498 # 509 #
501 # slot to the old version, then the old version gets left behind 512 # slot to the old version, then the old version gets left behind
502 # 513 #
503 # if USE=-vhosts, then we want to remove the old version, because 514 # if USE=-vhosts, then we want to remove the old version, because
504 # the user is relying on portage to do the magical thing for it 515 # the user is relying on portage to do the magical thing for it
505 516
506 if [ "$IS_UPGRADE" = "1" ] ; then 517 if [ "${IS_UPGRADE}" = "1" ] ; then
507 einfo "Removing old version $REMOVE_PKG" 518 einfo "Removing old version ${REMOVE_PKG}"
508 519
509 emerge -C "$REMOVE_PKG" 520 emerge -C "${REMOVE_PKG}"
510 fi 521 fi
511 else 522 else
512 # vhosts flag is on 523 # vhosts flag is on
513 # 524 #
514 # let's tell the administrator what to do next 525 # let's tell the administrator what to do next
516 einfo 527 einfo
517 einfo "The 'vhosts' USE flag is switched ON" 528 einfo "The 'vhosts' USE flag is switched ON"
518 einfo "This means that Portage will not automatically run webapp-config to" 529 einfo "This means that Portage will not automatically run webapp-config to"
519 einfo "complete the installation." 530 einfo "complete the installation."
520 einfo 531 einfo
521 einfo "To install $PN-$PVR into a virtual host, run the following command:" 532 einfo "To install ${PN}-${PVR} into a virtual host, run the following command:"
522 einfo 533 einfo
523 einfo " webapp-config -I -h <host> -d $PN $PN $PVR" 534 einfo " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}"
524 einfo 535 einfo
525 einfo "For more details, see the webapp-config(8) man page" 536 einfo "For more details, see the webapp-config(8) man page"
526 fi 537 fi
527 538
528 return 0 539 return 0
533 # remove any virtual installs that there are 544 # remove any virtual installs that there are
534 545
535 local my_output 546 local my_output
536 local x 547 local x
537 548
538 my_output="`webapp-config --list-installs $PN $PVR`" 549 my_output="$(${WEBAPP_CONFIG} --list-installs ${PN} ${PVR})"
539 550
540 if [ "$?" != "0" ]; then 551 if [ "${?}" != "0" ]; then
541 return 552 return
542 fi 553 fi
543 554
544 # the changes to IFS here are necessary to ensure that we can cope
545 # with directories that contain spaces in the file names
546
547 # OLD_IFS="$IFS"
548 # IFS=" "
549
550 for x in $my_output ; do 555 for x in ${my_output} ; do
551 # IFS="$OLD_IFS"
552
553 [ -f $x/.webapp ] && . $x/.webapp || ewarn "Cannot find file $x/.webapp" 556 [ -f ${x}/.webapp ] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp"
554 557
555 if [ -z "WEB_HOSTNAME" -o -z "WEB_INSTALLDIR" ]; then 558 if [ -z "${WEB_HOSTNAME}" -o -z "${WEB_INSTALLDIR}" ]; then
556 ewarn "Don't forget to use webapp-config to remove the copy of" 559 ewarn "Don't forget to use webapp-config to remove the copy of"
557 ewarn "${PN}-${PVR} installed in" 560 ewarn "${PN}-${PVR} installed in"
558 ewarn 561 ewarn
559 ewarn " $x" 562 ewarn " ${x}"
560 ewarn 563 ewarn
561 else 564 else
562 # we have enough information to remove the virtual copy ourself 565 # we have enough information to remove the virtual copy ourself
563 566
564 webapp-config -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR} 567 ${WEBAPP_CONFIG} -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR}
565 568
566 # if the removal fails - we carry on anyway! 569 # if the removal fails - we carry on anyway!
567 fi 570 fi
568 # IFS=" "
569 done 571 done
570
571 # IFS="$OLD_IFS"
572} 572}

Legend:
Removed from v.1.34  
changed lines
  Added in v.1.41

  ViewVC Help
Powered by ViewVC 1.1.20